# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from dccomms_ros_msgs/AddAcousticChannelRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class AddAcousticChannelRequest(genpy.Message):
  _md5sum = "aec257636b381c5decea84ec99b6fbb5"
  _type = "dccomms_ros_msgs/AddAcousticChannelRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint32 id

#Bandwidth of propagation in Hz
float64 bandwidth

#Temperature of water (C)
float64 temperature

#Salinty of water (ppt)
float64 salinity

#Noise level in dB
float64 noiseLvl

#Logging
string logLevel
"""
  __slots__ = ['id','bandwidth','temperature','salinity','noiseLvl','logLevel']
  _slot_types = ['uint32','float64','float64','float64','float64','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       id,bandwidth,temperature,salinity,noiseLvl,logLevel

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AddAcousticChannelRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.id is None:
        self.id = 0
      if self.bandwidth is None:
        self.bandwidth = 0.
      if self.temperature is None:
        self.temperature = 0.
      if self.salinity is None:
        self.salinity = 0.
      if self.noiseLvl is None:
        self.noiseLvl = 0.
      if self.logLevel is None:
        self.logLevel = ''
    else:
      self.id = 0
      self.bandwidth = 0.
      self.temperature = 0.
      self.salinity = 0.
      self.noiseLvl = 0.
      self.logLevel = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_I4d().pack(_x.id, _x.bandwidth, _x.temperature, _x.salinity, _x.noiseLvl))
      _x = self.logLevel
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 36
      (_x.id, _x.bandwidth, _x.temperature, _x.salinity, _x.noiseLvl,) = _get_struct_I4d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.logLevel = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.logLevel = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_I4d().pack(_x.id, _x.bandwidth, _x.temperature, _x.salinity, _x.noiseLvl))
      _x = self.logLevel
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 36
      (_x.id, _x.bandwidth, _x.temperature, _x.salinity, _x.noiseLvl,) = _get_struct_I4d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.logLevel = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.logLevel = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_I4d = None
def _get_struct_I4d():
    global _struct_I4d
    if _struct_I4d is None:
        _struct_I4d = struct.Struct("<I4d")
    return _struct_I4d
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from dccomms_ros_msgs/AddAcousticChannelResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class AddAcousticChannelResponse(genpy.Message):
  _md5sum = "e27848a10f8e7e4030443887dfea101b"
  _type = "dccomms_ros_msgs/AddAcousticChannelResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """bool res

"""
  __slots__ = ['res']
  _slot_types = ['bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       res

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AddAcousticChannelResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.res is None:
        self.res = False
    else:
      self.res = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.res
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.res,) = _get_struct_B().unpack(str[start:end])
      self.res = bool(self.res)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.res
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.res,) = _get_struct_B().unpack(str[start:end])
      self.res = bool(self.res)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
class AddAcousticChannel(object):
  _type          = 'dccomms_ros_msgs/AddAcousticChannel'
  _md5sum = '5eea0ae892295e26164b914f98923a56'
  _request_class  = AddAcousticChannelRequest
  _response_class = AddAcousticChannelResponse
