# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from dccomms_ros_msgs/AddAcousticDeviceRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class AddAcousticDeviceRequest(genpy.Message):
  _md5sum = "86ed4686a8f2c94eef4b4c994ceef140"
  _type = "dccomms_ros_msgs/AddAcousticDeviceRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """string dccommsId
uint32 type
uint32 mac
string frameId
uint32 maxTxFifoSize

#Battery energy (J)
float64 batteryEnergy

#Symbols per second
uint32 symbolsPerSecond

#The coding efficiency: number of symbols per bit.
float64 codingEff

#The bit error rate.
float64 bitErrorRate

#Maximum transmission range in m (W).
float64 range

#Transmitted signal power (W).
float64 PT

#The frequency, default is 25(khz).
float64 frequency

#System loss default factor
float64 L

#Energy spread factor, spherical spreading
float64 K

#Energy consumption for turning on the modem (J)
float64 turnOnEnergy

#Energy consumption for turning off the modem (J)
float64 turnOffEnergy

#Duration of preamble
float64 preamble

#Power consumption for transmission (W). Default is 0.660 (1.6W).
float64 PTConsume

#Power consumption for reception (W). Default is 0.395 (1.2W).
float64 PRConsume

#Idle power consumption (W). Default is 0.0 (0W).
float64 PIdle

#Mac protocol: broadcast MAC ; T-MAC ; FAMA ; Slotted-FAMA ; UWAN-MAC ; COPE-MAC ; ALOHA ; R-MAC ; GOAL
string macProtocol
float64 macDistance

#Logging
string logLevel

"""
  __slots__ = ['dccommsId','type','mac','frameId','maxTxFifoSize','batteryEnergy','symbolsPerSecond','codingEff','bitErrorRate','range','PT','frequency','L','K','turnOnEnergy','turnOffEnergy','preamble','PTConsume','PRConsume','PIdle','macProtocol','macDistance','logLevel']
  _slot_types = ['string','uint32','uint32','string','uint32','float64','uint32','float64','float64','float64','float64','float64','float64','float64','float64','float64','float64','float64','float64','float64','string','float64','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       dccommsId,type,mac,frameId,maxTxFifoSize,batteryEnergy,symbolsPerSecond,codingEff,bitErrorRate,range,PT,frequency,L,K,turnOnEnergy,turnOffEnergy,preamble,PTConsume,PRConsume,PIdle,macProtocol,macDistance,logLevel

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AddAcousticDeviceRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.dccommsId is None:
        self.dccommsId = ''
      if self.type is None:
        self.type = 0
      if self.mac is None:
        self.mac = 0
      if self.frameId is None:
        self.frameId = ''
      if self.maxTxFifoSize is None:
        self.maxTxFifoSize = 0
      if self.batteryEnergy is None:
        self.batteryEnergy = 0.
      if self.symbolsPerSecond is None:
        self.symbolsPerSecond = 0
      if self.codingEff is None:
        self.codingEff = 0.
      if self.bitErrorRate is None:
        self.bitErrorRate = 0.
      if self.range is None:
        self.range = 0.
      if self.PT is None:
        self.PT = 0.
      if self.frequency is None:
        self.frequency = 0.
      if self.L is None:
        self.L = 0.
      if self.K is None:
        self.K = 0.
      if self.turnOnEnergy is None:
        self.turnOnEnergy = 0.
      if self.turnOffEnergy is None:
        self.turnOffEnergy = 0.
      if self.preamble is None:
        self.preamble = 0.
      if self.PTConsume is None:
        self.PTConsume = 0.
      if self.PRConsume is None:
        self.PRConsume = 0.
      if self.PIdle is None:
        self.PIdle = 0.
      if self.macProtocol is None:
        self.macProtocol = ''
      if self.macDistance is None:
        self.macDistance = 0.
      if self.logLevel is None:
        self.logLevel = ''
    else:
      self.dccommsId = ''
      self.type = 0
      self.mac = 0
      self.frameId = ''
      self.maxTxFifoSize = 0
      self.batteryEnergy = 0.
      self.symbolsPerSecond = 0
      self.codingEff = 0.
      self.bitErrorRate = 0.
      self.range = 0.
      self.PT = 0.
      self.frequency = 0.
      self.L = 0.
      self.K = 0.
      self.turnOnEnergy = 0.
      self.turnOffEnergy = 0.
      self.preamble = 0.
      self.PTConsume = 0.
      self.PRConsume = 0.
      self.PIdle = 0.
      self.macProtocol = ''
      self.macDistance = 0.
      self.logLevel = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.dccommsId
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.type, _x.mac))
      _x = self.frameId
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_IdI13d().pack(_x.maxTxFifoSize, _x.batteryEnergy, _x.symbolsPerSecond, _x.codingEff, _x.bitErrorRate, _x.range, _x.PT, _x.frequency, _x.L, _x.K, _x.turnOnEnergy, _x.turnOffEnergy, _x.preamble, _x.PTConsume, _x.PRConsume, _x.PIdle))
      _x = self.macProtocol
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.macDistance
      buff.write(_get_struct_d().pack(_x))
      _x = self.logLevel
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.dccommsId = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.dccommsId = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.type, _x.mac,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.frameId = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.frameId = str[start:end]
      _x = self
      start = end
      end += 120
      (_x.maxTxFifoSize, _x.batteryEnergy, _x.symbolsPerSecond, _x.codingEff, _x.bitErrorRate, _x.range, _x.PT, _x.frequency, _x.L, _x.K, _x.turnOnEnergy, _x.turnOffEnergy, _x.preamble, _x.PTConsume, _x.PRConsume, _x.PIdle,) = _get_struct_IdI13d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.macProtocol = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.macProtocol = str[start:end]
      start = end
      end += 8
      (self.macDistance,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.logLevel = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.logLevel = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.dccommsId
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.type, _x.mac))
      _x = self.frameId
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_IdI13d().pack(_x.maxTxFifoSize, _x.batteryEnergy, _x.symbolsPerSecond, _x.codingEff, _x.bitErrorRate, _x.range, _x.PT, _x.frequency, _x.L, _x.K, _x.turnOnEnergy, _x.turnOffEnergy, _x.preamble, _x.PTConsume, _x.PRConsume, _x.PIdle))
      _x = self.macProtocol
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.macDistance
      buff.write(_get_struct_d().pack(_x))
      _x = self.logLevel
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.dccommsId = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.dccommsId = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.type, _x.mac,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.frameId = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.frameId = str[start:end]
      _x = self
      start = end
      end += 120
      (_x.maxTxFifoSize, _x.batteryEnergy, _x.symbolsPerSecond, _x.codingEff, _x.bitErrorRate, _x.range, _x.PT, _x.frequency, _x.L, _x.K, _x.turnOnEnergy, _x.turnOffEnergy, _x.preamble, _x.PTConsume, _x.PRConsume, _x.PIdle,) = _get_struct_IdI13d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.macProtocol = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.macProtocol = str[start:end]
      start = end
      end += 8
      (self.macDistance,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.logLevel = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.logLevel = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_IdI13d = None
def _get_struct_IdI13d():
    global _struct_IdI13d
    if _struct_IdI13d is None:
        _struct_IdI13d = struct.Struct("<IdI13d")
    return _struct_IdI13d
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from dccomms_ros_msgs/AddAcousticDeviceResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class AddAcousticDeviceResponse(genpy.Message):
  _md5sum = "e27848a10f8e7e4030443887dfea101b"
  _type = "dccomms_ros_msgs/AddAcousticDeviceResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """bool res

"""
  __slots__ = ['res']
  _slot_types = ['bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       res

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AddAcousticDeviceResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.res is None:
        self.res = False
    else:
      self.res = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.res
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.res,) = _get_struct_B().unpack(str[start:end])
      self.res = bool(self.res)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.res
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.res,) = _get_struct_B().unpack(str[start:end])
      self.res = bool(self.res)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
class AddAcousticDevice(object):
  _type          = 'dccomms_ros_msgs/AddAcousticDevice'
  _md5sum = '34cb4c9adcd172c295f171d528dc1b10'
  _request_class  = AddAcousticDeviceRequest
  _response_class = AddAcousticDeviceResponse
